/* ----------------------------------------------------------------------------
 * shiori.c
 *   <<boundary>>
 *   栞と里珠/Proxy 間のインターフェース.
 * ----------------------------------------------------------------------------
 * Mastering programed by YAMASHINA Hio
 *
 * Copyright 2002 YMIRLINK,Inc.
 * ----------------------------------------------------------------------------
 * $Id: shiori.c,v 1.3 2002/11/09 11:03:44 hio Exp $
 * ----------------------------------------------------------------------------
 */

#include <windows.h>
#define SHIORI_API_IMPLEMENTS
#include "shiori.h"

#include "rishu_proxy.h"

/* ----------------------------------------------------------------------------
 * rishuProxy
 *   里珠/Proxy のインスタンス
 */
static RishuProxy* rishuProxy;

/* ----------------------------------------------------------------------------
 * DllMain
 */
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
		       )
{
  switch (ul_reason_for_call)
  {
  case DLL_PROCESS_ATTACH:
    {
      /* 里珠/Proxy の初期化. */
      rishuProxy = (RishuProxy*)GlobalAlloc(GMEM_FIXED,sizeof(*rishuProxy));
      RishuProxy_init(rishuProxy,sizeof(*rishuProxy),hModule);
      break;
    }
  case DLL_THREAD_ATTACH:
  case DLL_THREAD_DETACH:
    break;
  case DLL_PROCESS_DETACH:
    {
      /* 里珠/Proxy の破棄. */
      RishuProxy_discard(rishuProxy);
      GlobalFree(rishuProxy);
      rishuProxy = NULL;
      break;
    }
    break;
  }
  return TRUE;
}

/* ----------------------------------------------------------------------------
 * 栞 Method / load
 */ 
SHIORI_API BOOL __cdecl load(HGLOBAL hGlobal_loaddir,
			     long loaddir_len
			     )
{
  if( !rishuProxy )
  {
    return FALSE;
  }
  return RishuProxy_on_load(rishuProxy,hGlobal_loaddir,loaddir_len);
}

/* ----------------------------------------------------------------------------
 * 栞 Method / request
 */
SHIORI_API HGLOBAL __cdecl request(HGLOBAL hGlobal_request,
				   long* ptr_len
				   )
{
  if( !rishuProxy )
  {
    return NULL;
  }
  return RishuProxy_on_request(rishuProxy,hGlobal_request,ptr_len);
}

/* ----------------------------------------------------------------------------
 * 栞 Method / unload
 */
SHIORI_API BOOL __cdecl unload(void)
{
  if( !rishuProxy )
  {
    return FALSE;
  }
  return RishuProxy_on_unload(rishuProxy);
}

